#ifndef I_NODE_PROCESSOR_HPP
#define I_NODE_PROCESSOR_HPP

#include <language/node_processor/ExecutionPolicy.hpp>
#include <language/utils/DataVariant.hpp>
#include <utils/Demangle.hpp>

#include <string>
#include <typeinfo>

struct INodeProcessor
{
  virtual DataVariant execute(ExecutionPolicy& exec_policy) = 0;

  std::string
  typeIdName() const
  {
    return demangle(typeid(*this).name());
  }

  INodeProcessor(const INodeProcessor&) = delete;
  INodeProcessor(INodeProcessor&&)      = delete;

  INodeProcessor() = default;

  virtual ~INodeProcessor() = default;
};

#endif   // I_NODE_PROCESSOR_HPP
